[devtools,2/4] lib/common.sh: lock, slock: Allow locks to be inherited.

Message ID 20170325163441.28555-3-lukeshu@parabola.nu
State Accepted
Headers show
Series [devtools,1/4] lib/common.sh: add 'lock_close'; use it as appropriate. | expand

Commit Message

Luke Shumaker March 25, 2017, 4:34 p.m. UTC
Allow for locks to be inherited.  Inheriting the lock is something that
mkarchroot could do previously, but has since lost the ability to do.  This
allows for the programs to be more compos-able.

Do this by instead of unconditionally opening $file on $fd, first check if
$file is already open on $fd; and go ahead use it if it is.

The naive way of doing this would be to `$(readlink /dev/fd/$fd)` and
compare that to `$file`.  However, if `$file` is itself a symlink; or there
is a symlink somewhere in the path to `$file`, then this could easily fail.
Instead, check `[[ "/dev/fd/$fd" -ef "$file" ]]`.  Even though the Bash
documentation (`help test`) says that `-ef` checks for if the two files are
hard links to eachother, because it uses stat(3) (which resolves symlinks)
to do this check, it also works with the /dev/fd/ soft links.
---
 lib/common.sh | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

Patch

diff --git a/lib/common.sh b/lib/common.sh
index 689772f..63b7795 100644
--- a/lib/common.sh
+++ b/lib/common.sh
@@ -138,7 +138,11 @@  get_full_version() {
 #  usage : lock( $fd, $file, $message )
 ##
 lock() {
-	eval "exec $1>"'"$2"'
+	# Only reopen the FD if it wasn't handed to us
+	if ! [[ "/dev/fd/$1" -ef "$2" ]]; then
+		eval "exec $1>"'"$2"'
+	fi
+
 	if ! flock -n $1; then
 		stat_busy "$3"
 		flock $1
@@ -150,7 +154,11 @@  lock() {
 #  usage : slock( $fd, $file, $message )
 ##
 slock() {
-	eval "exec $1>"'"$2"'
+	# Only reopen the FD if it wasn't handed to us
+	if ! [[ "/dev/fd/$1" -ef "$2" ]]; then
+		eval "exec $1>"'"$2"'
+	fi
+
 	if ! flock -sn $1; then
 		stat_busy "$3"
 		flock -s $1